#include <iostream>
#include <string>
#include "configparser.hpp"

int main(int argc, char* argv[])
{
  aul::ConfigParser cfgParser;
  
  bool invertMouse;
  bool showFPS;
  int width;
  int height;
  double number;
  std::string name;


  // This is all you need to do to use my config stuff
  // Add the things you want read...  
  cfgParser.AddItem("invertmouse", &invertMouse, true);
  cfgParser.AddItem("showfps", &showFPS, true);
  cfgParser.AddItem("width", &width, 1024);
  cfgParser.AddItem("height", &height, 768);
  cfgParser.AddItem("number", &number, 42.0);
  cfgParser.AddItem("name", &name);
  
  // ...and parse the file. You don't have to bother
  // with the errors since the whole file will be parsed
  // anyway. The only reason you can check for errors
  // is in case you misspelled something or made some
  // other misstake in the config file
  int error = cfgParser.ParseFile("config.txt");
    
  // Handle the errors if you want to know what
  // went wrong
  if(error == aul::CFG_ERROR::PARSE_ERROR)
    cfgParser.PrintErrors(std::cout);
  else if(error == aul::CFG_ERROR::FILE_ERROR)
    std::cout<<"Unable to load cfg file";
  else if(error == aul::CFG_ERROR::SUCCESS)
    std::cout<<"Yeah";
    
  
  std::cout<<std::endl;
  std::cout<<std::endl;
  std::cout<<std::endl;
  
  std::cout<<"invertmouse: \t"<<invertMouse<<std::endl;
  std::cout<<"showfps: \t"<<showFPS<<std::endl;
  std::cout<<"width: \t\t"<<width<<std::endl;
  std::cout<<"height: \t"<<height<<std::endl;
  std::cout<<"number: \t"<<number<<std::endl;
  std::cout<<"name: \t\t"<<name<<std::endl;
  
  cfgParser.SaveFile();  
  
  std::cin.get();

  return 0;
}
